/*
 * UNC001 firmware. (c) Unicontrollers, Ltd., 2010-2014
 *
 * Please see the files README, COPYING, LICENSE and WARRANTY
 * for some useful details on the legal status of this code.
 * Visit the site http://www.unicontrollers.com for more info.
 *
 * file unc_prim.h
 * Primary functions of the device: what the device actually can do
 *
 * Written by Andrey V. Stolyarov
 *
 */

#ifndef UNC_PRIM_H_SENTRY
#define UNC_PRIM_H_SENTRY

#include "unc_data.h"

extern struct unc0xx_global_configuration_str global_configuration;
extern struct unc0xx_global_state_str global_state;
extern struct unc0xx_extra_state_str_onewire extra_state;
extern struct unc0xx_extra_state_str_delays delay_state;

void init_primary_hardware();

void startup_hook();

void restore_factory_defaults();
void sync_global_state();
void zero_counters(uint16_t *save);
void save_registers_to_eeprom();
void perform_action(uint8_t grp, uint8_t action);
void do_input_confirmation();

void schedule_delayed_action_cycles(uint8_t loc,
                                    uint8_t grp, uint8_t act, uint32_t del);
void schedule_delayed_action(uint8_t loc, const uint8_t *reg);
void process_delayed_actions();

void global_state_putchar(uint8_t ch);
void global_state_drop_message();

#endif
