/*
 * UNC001 host-side software. (c) Unicontrollers, Ltd., 2010-2014
 *
 * Please see the files README, COPYING, LICENSE and WARRANTY
 * for some useful details on the legal status of this code.
 * Visit the site http://www.unicontrollers.com for more info.
 *
 * file unc_prot.h
 * Protocol conventions (e.g. request id's and magic numbers) for
 * communication between the device and the host software
 *
 * Written by Andrey V. Stolyarov
 *
 */

#ifndef UNC_PROT_H_SENTRY
#define UNC_PROT_H_SENTRY


    /* last 6 digits are YYMMDD, the first is the 'major' version */
#define UNC_VERSION 4141014

enum unc_prot_requests {
    uncreq_query_eeprom = 1,
    uncreq_query_configuration = 2, /* bytes 4..7 of 64 contain the version */
    uncreq_query_fullstate = 3,
    uncreq_command = 4,
    uncreq_long_command = 5,
    /* uncreq_com_poll = uncreq_long_command, */
    uncreq_zero_query_counters = 6,
    uncreq_query_extrastate = 7
};

enum unc_prot_commands {
    uncreqcmd_set_hwconfig = 21,
    uncreqcmd_set_userconfig = 22,
    uncreqcmd_set_id = 23,
    uncreqcmd_set_reactions = 24,
    uncreqcmd_save_to_eeprom = 25,
    uncreqcmd_restore_from_eeprom = 26,
    uncreqcmd_restore_factory = 27,
    uncreqcmd_action = 28,
    uncreqlcmd_delayed_action = 29,
#if 0
    uncreqcmd_com_release = 29,
    uncreqlcmd_com_message = 30,
    uncreqlcmd_bus_command = 31,
#endif
    uncreqcmd_clear_msg = 32,
    uncreqlcmd_write_e_reg = 33,
    uncreqcmd_reset_1wire = 34
};


#endif
