/*
 * UNC0xx GUI-based software. (c) Unicontrollers, Ltd., 2012
 *
 * Please see the files README, COPYING, LICENSE and WARRANTY
 * for some useful details on the legal status of this code.
 * Visit the site http://www.unicontrollers.com for more info.
 *
 * file aboutdlg.cpp
 * Implementation of the About dialog
 *
 * Written by Andrey V. Stolyarov
 *
 */

#include <wx/dialog.h>
#include <wx/sizer.h>
#include <wx/stattext.h>
#include <wx/timer.h>
#include <wx/image.h>
#include <wx/statbmp.h>
#include <wx/mstream.h>



class UNCAboutDialog: public wxDialog {
public:
    UNCAboutDialog();
    ~UNCAboutDialog();

private:
    void OnOk(wxCommandEvent& event);
    DECLARE_EVENT_TABLE();
};

#include "_unc_logo.inc"

UNCAboutDialog::UNCAboutDialog()
    : wxDialog(NULL, -1, wxT("UNC Monitor: About"), wxDefaultPosition,
               wxDefaultSize, wxCAPTION)
{
    wxBoxSizer *mains = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer *hor = new wxBoxSizer(wxHORIZONTAL);


    wxImage::AddHandler(new wxPNGHandler);
    wxMemoryInputStream strm(unc_logo, sizeof(unc_logo));
    wxImage img;
    img.LoadFile(strm, wxBITMAP_TYPE_PNG);
    wxBitmap bmp(img);
    hor->Add(new wxStaticBitmap(this, wxID_ANY, bmp,
                                wxDefaultPosition, wxSize(150, 150)));

    hor->Add(new wxStaticText(this, wxID_STATIC,
        wxT("The UNC Monitor program:\n"
        "UNC0xx managed electric switches control\n"
        "\n"
        "(C) Unicontrollers, Ltd., 2012\n"
        "http://www.unicontrollers.com\n"
        "\n"
        "This is free software, distributed under\n"
        "the terms and conditions of GNU GPL v.3\n"
        "Please see the file gnu_gpl.txt for details.\n"
        "The program comes free of charge and with\n"
        "ABSOLUTELY NO WARRANTY\n")));

    mains->Add(hor);

    wxSizer *s = CreateSeparatedButtonSizer(wxOK);
    mains->Add(s, 0, wxEXPAND);

    mains->SetSizeHints(this);
    SetSizer(mains);
    Fit();
}

UNCAboutDialog::~UNCAboutDialog()
{
}

void UNCAboutDialog::OnOk(wxCommandEvent& event)
{
    delete this;
}

BEGIN_EVENT_TABLE(UNCAboutDialog, wxDialog)
    EVT_BUTTON(wxID_OK,     UNCAboutDialog::OnOk)
END_EVENT_TABLE()



///////////////////////////////////////////////////////////////////////

void LaunchAboutDialog()
{
    UNCAboutDialog *dlg = new UNCAboutDialog();
    dlg->ShowModal();
}
